/**
 * Body mixin
 *
 * Ref: https://fetch.spec.whatwg.org/#body
 *
 * @param   Stream  body  Readable stream
 * @param   Object  opts  Response options
 * @return  Void
 */
export default class Body {
    constructor(body: any, { size }?: {
        size?: number | undefined;
    });
    size: number;
    get body(): any;
    get bodyUsed(): boolean;
    /**
     * Decode response as ArrayBuffer
     *
     * @return  Promise
     */
    arrayBuffer(): Promise<any>;
    /**
     * Return raw response as Blob
     *
     * @return Promise
     */
    blob(): Promise<any>;
    /**
     * Decode response as json
     *
     * @return  Promise
     */
    json(): Promise<any>;
    /**
     * Decode response as text
     *
     * @return  Promise
     */
    text(): Promise<any>;
    [INTERNALS]: {
        body: any;
        boundary: null;
        disturbed: boolean;
        error: null;
    };
}
import { BODY as INTERNALS } from './INTERNALS';
