/**
 * Response class
 *
 * @param   Stream  body  Readable stream
 * @param   Object  opts  Response options
 * @return  Void
 */
export default class fakeResponse extends Body {
    /**
     * @param {string} url    The URL that the new response is to originate from.
     * @param {number} status An optional status code for the response (e.g., 302.)
     * @return {Response}    A Response object.
     */
    static redirect(url: string, status?: number): Response;
    static error(): Response;
    constructor(body?: null, options?: {});
    get type(): string;
    get url(): any;
    get status(): any;
    /**
     * Convenience property representing if the request ended normally
     */
    get ok(): boolean;
    get redirected(): boolean;
    get statusText(): any;
    get headers(): Headers;
    /**
     * Clone this response
     *
     * @return  Response
     */
    clone(): Response;
    get [Symbol.toStringTag](): string;
    [INTERNALS]: {
        type: string;
        url: any;
        status: any;
        statusText: any;
        headers: Headers;
        counter: any;
    };
}
import Body from './body';
import { RESPONSE as INTERNALS } from './INTERNALS';
declare const Response: {
    new (body?: BodyInit | null | undefined, init?: ResponseInit | undefined): Response;
    prototype: Response;
    error(): Response;
    json(data: any, init?: ResponseInit | undefined): Response;
    redirect(url: string | URL, status?: number | undefined): Response;
};
export {};
